"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var getSimilarAdjacentBlocks = function getSimilarAdjacentBlocks(editorState, block) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var blockType = block.getType();
  var depth = block.getDepth();
  var variant = block.getData().get('variant');
  var contentState = editorState.getCurrentContent();
  var _options$includeDepth = options.includeDepth,
      includeDepth = _options$includeDepth === void 0 ? true : _options$includeDepth,
      _options$onlyForBlock = options.onlyForBlockTypes,
      onlyForBlockTypes = _options$onlyForBlock === void 0 ? [] : _options$onlyForBlock;

  var matches = function matches(aBlock) {
    return aBlock && [aBlock.getType() === blockType, !includeDepth || aBlock.getDepth() === depth, aBlock.getData().get('variant') === variant, !onlyForBlockTypes.length || onlyForBlockTypes.includes(aBlock.getType())].every(Boolean);
  };

  var before = [];
  var after = [];
  var cursor = block;

  while (cursor) {
    var prev = contentState.getBlockBefore(cursor.getKey());

    if (matches(prev)) {
      before.push(prev);
      cursor = prev;
    } else {
      cursor = null;
    }
  }

  cursor = block;

  while (cursor) {
    var next = contentState.getBlockAfter(cursor.getKey());

    if (matches(next)) {
      after.push(next);
      cursor = next;
    } else {
      cursor = null;
    }
  }

  return {
    before: before.reverse(),
    after: after,
    all: [].concat(_toConsumableArray(before.reverse()), [block], after)
  };
};

var _default = getSimilarAdjacentBlocks;
exports["default"] = _default;